package mpi.eudico.client.annotator.nativemedia.quartztypelib.server;

import com.jniwrapper.*;
import com.jniwrapper.win32.*;
import com.jniwrapper.win32.automation.*;
import com.jniwrapper.win32.automation.impl.*;
import com.jniwrapper.win32.automation.server.*;
import com.jniwrapper.win32.automation.types.*;
import com.jniwrapper.win32.com.*;
import com.jniwrapper.win32.com.impl.*;
import com.jniwrapper.win32.com.server.*;
import com.jniwrapper.win32.com.types.*;
import mpi.eudico.client.annotator.nativemedia.quartztypelib.*;
import mpi.eudico.client.annotator.nativemedia.quartztypelib.impl.*;

/**
 * Represents VTBL for COM interface IBasicVideo
 */
public class IBasicVideoVTBL extends IDispatchVTBL
{
    public IBasicVideoVTBL(CoClassMetaInfo classMetaInfo)
    {
        super(classMetaInfo);

        addMembers(
            new VirtualMethodCallback[] {
                new VirtualMethodCallback(
                    "getAvgTimePerFrame",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new DoubleFloat())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "getBitRate",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "getBitErrorRate",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "getVideoWidth",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "getVideoHeight",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "setSourceLeft",
                    new HResult(),
                    new Parameter[] {
                        new Int32()
                    }
                ),
                new VirtualMethodCallback(
                    "getSourceLeft",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "setSourceWidth",
                    new HResult(),
                    new Parameter[] {
                        new Int32()
                    }
                ),
                new VirtualMethodCallback(
                    "getSourceWidth",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "setSourceTop",
                    new HResult(),
                    new Parameter[] {
                        new Int32()
                    }
                ),
                new VirtualMethodCallback(
                    "getSourceTop",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "setSourceHeight",
                    new HResult(),
                    new Parameter[] {
                        new Int32()
                    }
                ),
                new VirtualMethodCallback(
                    "getSourceHeight",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "setDestinationLeft",
                    new HResult(),
                    new Parameter[] {
                        new Int32()
                    }
                ),
                new VirtualMethodCallback(
                    "getDestinationLeft",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "setDestinationWidth",
                    new HResult(),
                    new Parameter[] {
                        new Int32()
                    }
                ),
                new VirtualMethodCallback(
                    "getDestinationWidth",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "setDestinationTop",
                    new HResult(),
                    new Parameter[] {
                        new Int32()
                    }
                ),
                new VirtualMethodCallback(
                    "getDestinationTop",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "setDestinationHeight",
                    new HResult(),
                    new Parameter[] {
                        new Int32()
                    }
                ),
                new VirtualMethodCallback(
                    "getDestinationHeight",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32())
                    },
                    0
                ),
                new VirtualMethodCallback(
                    "setSourcePosition",
                    new HResult(),
                    new Parameter[] {
                        new Int32(),
                        new Int32(),
                        new Int32(),
                        new Int32()
                    }
                ),
                new VirtualMethodCallback(
                    "getSourcePosition",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32()),
                        new Pointer.OutOnly(new Int32()),
                        new Pointer.OutOnly(new Int32()),
                        new Pointer.OutOnly(new Int32())
                    }
                ),
                new VirtualMethodCallback(
                    "setDefaultSourcePosition",
                    new HResult(),
                    new Parameter[] {
                    }
                ),
                new VirtualMethodCallback(
                    "setDestinationPosition",
                    new HResult(),
                    new Parameter[] {
                        new Int32(),
                        new Int32(),
                        new Int32(),
                        new Int32()
                    }
                ),
                new VirtualMethodCallback(
                    "getDestinationPosition",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32()),
                        new Pointer.OutOnly(new Int32()),
                        new Pointer.OutOnly(new Int32()),
                        new Pointer.OutOnly(new Int32())
                    }
                ),
                new VirtualMethodCallback(
                    "setDefaultDestinationPosition",
                    new HResult(),
                    new Parameter[] {
                    }
                ),
                new VirtualMethodCallback(
                    "getVideoSize",
                    new HResult(),
                    new Parameter[] {
                        new Pointer.OutOnly(new Int32()),
                        new Pointer.OutOnly(new Int32())
                    }
                ),
                new VirtualMethodCallback(
                    "getVideoPaletteEntries",
                    new HResult(),
                    new Parameter[] {
                        new Int32(),
                        new Int32(),
                        new Pointer.OutOnly(new Int32()),
                        new Pointer.OutOnly(new Int32())
                    }
                ),
                new VirtualMethodCallback(
                    "getCurrentImage",
                    new HResult(),
                    new Parameter[] {
                        new Pointer(new Int32()),
                        new Pointer.OutOnly(new Int32())
                    }
                ),
                new VirtualMethodCallback(
                    "isUsingDefaultSource",
                    new HResult(),
                    new Parameter[] {
                    }
                ),
                new VirtualMethodCallback(
                    "isUsingDefaultDestination",
                    new HResult(),
                    new Parameter[] {
                    }
                )
            }
        );
    }
}