package mpi.eudico.client.annotator;


import java.util.List;
import java.util.Vector;


public class TierOrder{
    private Vector listeners;
    private List tierOrder;

    /**
     * Creates an empty Cursor.
     */
    public TierOrder() {
        listeners = new Vector();
        tierOrder = null;
    }

    /**
     * Sets the Tier Order
     *
     * @param tNames DOCUMENT ME!
     */
    public void setTierOrder(List tierOrderList) {
        tierOrder = tierOrderList;
        
        // Tell all the interested TierOrder about the change
        notifyListeners();
    }

    /**
     * Gets the TierOrder
     *
     * @return DOCUMENT ME!
     */
    public List getTierOrder() {
        return tierOrder;
    }

    /**
     * Tell all TierOrderListeners about a change in the
     * TierOrder
     */
    public void notifyListeners() {
        for (int i = 0; i < listeners.size(); i++) {
            ((TierOrderListener) listeners.elementAt(i)).updateTierOrder(tierOrder);
        }
    }

    /**
     * Add a listener for TierOrder events.
     *
     * @param listener the listener that wants to be notified for
     *        TierOrder events.
     */
    public void addTierOrderListener(TierOrderListener listener) {
        listeners.add(listener);
        listener.updateTierOrder(tierOrder);
    }

    /**
     * Remove a listener for TierOrder events.
     *
     * @param listener the listener that no longer wants to be notified for
     *        TierOrder events.
     */
    public void removeTierorderListener(
        TierOrderListener listener) {
        listeners.remove(listener);
    }

}
