package mpi.eudico.client.annotator.commands;

import javax.swing.Action;

import mpi.eudico.client.annotator.ElanLayoutManager;
import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.ViewerManager2;


/**
 * A command action that switches the application to annotation mode. This is
 * the default mode.
 *
 * @author Han Sloetjes
 */
public class AnnotationModeCA extends CommandAction {
    private ElanLayoutManager layoutManager;

    /**
     * Creates a new AnnotationModeCA instance
     *
     * @param theVM DOCUMENT ME!
     * @param layoutManager DOCUMENT ME!
     */
    public AnnotationModeCA(ViewerManager2 theVM,
        ElanLayoutManager layoutManager) {
        super(theVM, ELANCommandFactory.ANNOTATION_MODE);
        this.layoutManager = layoutManager;        
        putValue(Action.LONG_DESCRIPTION, ElanLocale.getString(ELANCommandFactory.ANNOTATION_MODE));
    }

    /**
     * DOCUMENT ME!
     */
    protected void newCommand() {
        command = ELANCommandFactory.createCommand(vm.getTranscription(),
                ELANCommandFactory.ANNOTATION_MODE);
    }

    /**
     * The receiver of this CommandAction is the layoutManager.
     *
     * @return DOCUMENT ME!
     */
    protected Object getReceiver() {
        return layoutManager;
    }

    /**
     * Returns null, no arguments need to be passed.
     *
     * @return DOCUMENT ME!
     */
    protected Object[] getArguments() {
        return new Object[] { ElanLayoutManager.NORMAL_MODE};
    }
}
