package mpi.eudico.client.annotator.commands;

import mpi.eudico.client.annotator.ViewerManager2;


/**
 * Creates a segmentation dialog.
 *
 * @author Han Sloetjes
 */
public class SegmentationDlgCA extends CommandAction {
    /**
     * Creates a SegmentationDlgCA instance
     *
     * @param viewerManager the viewermanager
     */
    public SegmentationDlgCA(ViewerManager2 viewerManager) {
        super(viewerManager, ELANCommandFactory.SEGMENTATION_DLG);
    }

    /**
     * Creates a new Command.
     */
    protected void newCommand() {
        command = ELANCommandFactory.createCommand(vm.getTranscription(),
                ELANCommandFactory.SEGMENTATION_DLG);
    }

    /**
     * Returns the receiver for the command.
     *
     * @return the receiver (the transcription)
     */
    protected Object getReceiver() {
        return vm.getTranscription();
    }

    /**
     * Returns the arguments for the command.
     *
     * @return null
     */
    protected Object[] getArguments() {
        return null;
    }
}
