package mpi.eudico.client.annotator.commands.global;

import java.awt.event.ActionEvent;

import javax.swing.JCheckBoxMenuItem;

import mpi.eudico.client.annotator.ElanFrame2;
import mpi.eudico.client.annotator.Preferences;

public class CreateMetadataViewerMA extends FrameMenuAction {	
    /**
     * Creates a new CreateMetadataViewerMA instance
     *
     * @param name name of the action
     * @param frame the parent frame
     */
    public CreateMetadataViewerMA(String name, ElanFrame2 frame) {
        super(name, frame);        
    }

    /**
     * Sets the preference setting when changed 
     *
     * @param e the action event
     */
    public void actionPerformed(ActionEvent e) {
    	boolean value;
    	if( e.getSource() instanceof JCheckBoxMenuItem){    
    		value = ((JCheckBoxMenuItem)e.getSource()).isSelected();
    		Preferences.set(commandId, value , null, false);
    		if(frame.isIntialized()){
    			updateElanLayout(value);
    		}
    	}       
    }
    /** Adds or destroys the metadata viewer from the
     *  Elan layout
     * 
     * @param value if true adds the metadata view, if
     *        false, destroys the metadata view
     */
    
    private void updateElanLayout(boolean value){
    	if(value){
        		frame.getLayoutManager().add(frame.getViewerManager().createMetadataViewer());  
        }else{        	
           	frame.getLayoutManager().destroyViewer(frame.getViewerManager().getMetadataViewer());            	
            frame.getViewerManager().destroyMetaDataViewer();
        }    	
    }
}


