package mpi.eudico.client.annotator.commands.global;

import java.awt.event.ActionEvent;
import javax.swing.JCheckBoxMenuItem;

import mpi.eudico.client.annotator.ElanFrame2;
import mpi.eudico.client.annotator.Preferences;
import mpi.eudico.client.annotator.viewer.SubtitleViewer;

public class CreateSubtitleViewerMA extends FrameMenuAction {	
    /**
     * Creates a new CreateSubtitleViewerMA instance
     *
     * @param name name of the action
     * @param frame the parent frame
     */
    public CreateSubtitleViewerMA(String name, ElanFrame2 frame) {
        super(name, frame);        
    }

    /**
     * Sets the preference setting when changed 
     *
     * @param e the action event
     */
    public void actionPerformed(ActionEvent e) {
    	boolean value;
    	if( e.getSource() instanceof JCheckBoxMenuItem){    
    		value = ((JCheckBoxMenuItem)e.getSource()).isSelected();
    		Preferences.set(commandId, value , null, false);
    		if(frame.isIntialized()){
    			updateElanLayout(value);
    		}
    	}       
    }
    
    private void createSubtitleViewer(){
    	int numSubtitles = 4;
        Object val = Preferences.get("NumberOfSubtitleViewers", null);
        if (val instanceof Integer) {
        	numSubtitles = ((Integer) val).intValue();
        }
        
    	SubtitleViewer subtitleViewer;
    	for (int i = 0; i < numSubtitles; i++) {
    		subtitleViewer = frame.getViewerManager().createSubtitleViewer();
    		subtitleViewer.setViewerIndex(i + 1);    		
    			frame.getLayoutManager().add(subtitleViewer);
    	}
    }
    /** Adds or destroys the subtitle viewer from the
     *  Elan layout
     * 
     * @param value if true adds the subtitle view, if
     *        false, destroys the subtitle view
     */
    
    private void updateElanLayout(boolean value){
    	if(value){
        		createSubtitleViewer(); 
        }else{ 
//    		for (int i=0; i< frame.getViewerManager().getSubtitleViewers().size(); i++){
//    			frame.getLayoutManager().destroyViewer(frame.getViewerManager().getSubtitleViewers().elementAt(i)); 
//    		}    
        	if(frame.getViewerManager().getSubtitleViewers().size()> 0){
        		frame.getLayoutManager().destroyViewer(frame.getViewerManager().getSubtitleViewers().elementAt(0));
        	}
    		frame.getViewerManager().destroySubtitleViewers();  
        }    	
    }
}


