package mpi.eudico.client.annotator.commands.global;

import java.awt.event.ActionEvent;

import javax.swing.JCheckBoxMenuItem;

import mpi.eudico.client.annotator.ElanFrame2;
import mpi.eudico.client.annotator.Preferences;

public class CreateTextViewerMA extends FrameMenuAction {	
    /**
     * Creates a new CreateTextViewerMA instance
     *
     * @param name name of the action
     * @param frame the parent frame
     */
    public CreateTextViewerMA(String name, ElanFrame2 frame) {
        super(name, frame);        
    }

    /**
     * Sets the preference setting when changed 
     *
     * @param e the action event
     */
    public void actionPerformed(ActionEvent e) {
    	boolean value;
    	if( e.getSource() instanceof JCheckBoxMenuItem){    
    		value = ((JCheckBoxMenuItem)e.getSource()).isSelected();
    		Preferences.set(commandId, value , null, false);
    		if(frame.isIntialized()){
    			updateElanLayout(value);
    		}
    		
    	}       
    }
    
    /** Adds or destroys the text viewer from the
     *  Elan layout
     * 
     * @param value if true adds the text view, if
     *        false, destroys the text view
     */
    
    private void updateElanLayout(boolean value){
    	if(value){
        		frame.getLayoutManager().add(frame.getViewerManager().createTextViewer());  
        }else{        	
           	frame.getLayoutManager().destroyViewer(frame.getViewerManager().getTextViewer());            	
            frame.getViewerManager().destroyTextViewer(); 
        }    	
    }
}
