package mpi.eudico.client.annotator.commands.global;

import java.awt.event.ActionEvent;

import javax.swing.JCheckBoxMenuItem;

import mpi.eudico.client.annotator.ElanFrame2;
import mpi.eudico.client.annotator.Preferences;

public class CreateVideoRecognizerMA extends FrameMenuAction {	
    /**
     * Creates a new CreateVideoRecognizerMA instance
     *
     * @param name name of the action
     * @param frame the parent frame
     */
    public CreateVideoRecognizerMA(String name, ElanFrame2 frame) {
        super(name, frame);        
    }

    /**
     * Sets the preference setting when changed 
     *
     * @param e the action event
     */
    public void actionPerformed(ActionEvent e) {
    	boolean value;
    	if( e.getSource() instanceof JCheckBoxMenuItem){    
    		value = ((JCheckBoxMenuItem)e.getSource()).isSelected();
    		Preferences.set(commandId, value , null, false);
    		if(frame.isIntialized()){
    			updateElanLayout(value);
    		}
    	}       
    }
    
    /** Adds or destroys the video recognizer from the
     *  Elan layout
     * 
     * @param value if true adds the video recognizer , if
     *        false, destroys the video recognizer 
     */
    
    private void updateElanLayout(boolean value){
    	if(value){
    		if(frame.getViewerManager().getVideoPaths() != null && frame.getViewerManager().getVideoPaths().size() > 0){
        		frame.getLayoutManager().add(frame.getViewerManager().createVideoRecognizerPanel(frame.getViewerManager().getVideoPaths())); 
    		}
        }else{        	
           	frame.getLayoutManager().destroyViewer(frame.getViewerManager().getVideoRecognizerPanel());            	
            frame.getViewerManager().destroyPanel(frame.getViewerManager().getVideoRecognizerPanel()); 
        }    	
    }
}


