package mpi.eudico.client.annotator.layout;

public interface ModeLayoutManager {
	
	public void add(Object object);
	
	public void remove(Object object);
	
	public void doLayout();
	
	public void updateLocale();	
	
	public void clearLayout();	
	
	public void initComponents();
	
	public void enableOrDisableMenus(boolean enabled);

	/**
	 * Detaches the specified viewer or player.
	 * 
	 * @param object the viewer or player to remove from the main application frame
	 */
	public void detach(Object object);

	/**
	 * Attaches the specified viewer or player. 
	 *
	 * @param object the viewer or player to attach
	 */
	public void attach(Object object);	

	/**
	 * Notification of any change in the preferences.
	 * Can be ignored if the manager doesn't need it.
	 */
	public void preferencesChanged();

	public void cleanUpOnClose();
}
