package mpi.eudico.client.annotator.transcriptionMode;

import javax.swing.table.DefaultTableModel;

import mpi.eudico.client.annotator.ElanLocale;
import mpi.eudico.client.annotator.commands.ELANCommandFactory;
import mpi.eudico.server.corpora.clom.Annotation;

/**
 * Table model for the transcription table
 * 
 * @author aarsom
 *  
 */
public class TranscriptionTableModel extends DefaultTableModel {
	
	public final static String COLUMN0 = ElanLocale.getString(ELANCommandFactory.TRANS_TABLE_CLM_NO);
	public final static String COLUMN1_PREFIX = ElanLocale.getString(ELANCommandFactory.TRANS_TABLE_COLUMN1);
	public final static String COLUMN2_PREFIX = ElanLocale.getString(ELANCommandFactory.TRANS_TABLE_COLUMN2);
	public final static String COLUMN3_PREFIX = ElanLocale.getString(ELANCommandFactory.TRANS_TABLE_COLUMN3);
	
	private String column1Name = COLUMN1_PREFIX;
	private String column2Name = COLUMN2_PREFIX;
	private String column3Name = COLUMN3_PREFIX;
	
		
	final String columnsNames[] = {COLUMN0, column1Name, column2Name, column3Name};
	
	 public TranscriptionTableModel(){ 		
		 for (int i = 0; i < columnsNames.length; i++) {
			this.addColumn(columnsNames[i]);
		}
		 setColumnIdentifiers(columnsNames);
	 }
	 
	 public boolean isCellEditable(int row, int column) {
		 Object obj = getValueAt(row, column);
		 return ( obj instanceof Annotation || obj instanceof String);
	 }
	 
	 public void setNewIdentifiers(final String[] identifiers){
		 int size = identifiers.length;
		 switch(size){
		 case 3:
			 if(identifiers[2] != null){
				 column3Name = identifiers[2];
			 }
		 case 2:
			 if(identifiers[1] != null){
				 column2Name = identifiers[1];
			 }		 
		 case 1:
			 if(identifiers[0] != null){
				 column1Name = identifiers[0];
			 }
		 }
		 
		 String columnsNames[] = {COLUMN0, column1Name, column2Name, column3Name};
		 setColumnIdentifiers(columnsNames);
	 }
	 
//	 public void setColumnName(String prefix, String newName){
//		 
//		if(prefix.equals(COLUMN1_PREFIX)){
//			column1Name = newName;
//		}
//		if(prefix.equals(COLUMN2_PREFIX)){
//			column2Name = newName;
//		}
//		if(prefix.equals(COLUMN3_PREFIX)){
//			column3Name = newName;
//		}		 
//	 }
	 
	 public String getColumnNameForPrefix(String prefix){
		 String name = null;
		 
		 if(prefix.equals(COLUMN1_PREFIX)){
			name = column1Name;
		 } else if(prefix.equals(COLUMN2_PREFIX)){
			name = column2Name;
		 } else if(prefix.equals(COLUMN3_PREFIX)){
			name = column3Name;
		 }
		 
		 return name;
	 }

}
